(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (fixnum) (not safe))
  (define std/sort#sort
    (lambda (_seq2471_ _elt<2473_)
      (if (procedure? _elt<2473_)
          '#!void
          (error '"Expected procedure" _elt<2473_))
      (if (null? _seq2471_)
          _seq2471_
          (if (pair? _seq2471_)
              (std/sort#list-merge-sort _seq2471_ _elt<2473_)
              (if (vector? _seq2471_)
                  (std/sort#heap-sort _seq2471_ _elt<2473_)
                  (error '"Expected list or vector" _seq2471_))))))
  (define std/sort#sort!
    (lambda (_seq2466_ _elt<2468_)
      (if (procedure? _elt<2468_)
          '#!void
          (error '"Expected procedure" _elt<2468_))
      (if (null? _seq2466_)
          _seq2466_
          (if (pair? _seq2466_)
              (std/sort#list-merge-sort! _seq2466_ _elt<2468_)
              (if (vector? _seq2466_)
                  (std/sort#vector-heap-sort! _seq2466_ _elt<2468_)
                  (error '"Expected list or vector" _seq2466_))))))
  (define std/sort#stable-sort
    (lambda (_seq2461_ _elt<2463_)
      (if (procedure? _elt<2463_)
          '#!void
          (error '"Expected procedure" _elt<2463_))
      (if (null? _seq2461_)
          _seq2461_
          (if (pair? _seq2461_)
              (std/sort#list-merge-sort _seq2461_ _elt<2463_)
              (if (vector? _seq2461_)
                  (std/sort#vector-merge-sort _seq2461_ _elt<2463_)
                  (error '"Expected list or vector" _seq2461_))))))
  (define std/sort#stable-sort!
    (lambda (_seq2456_ _elt<2458_)
      (if (procedure? _elt<2458_)
          '#!void
          (error '"Expected procedure" _elt<2458_))
      (if (null? _seq2456_)
          _seq2456_
          (if (pair? _seq2456_)
              (std/sort#list-merge-sort! _seq2456_ _elt<2458_)
              (if (vector? _seq2456_)
                  (std/sort#vector-merge-sort! _seq2456_ _elt<2458_)
                  (error '"Expected list or vector" _seq2456_))))))
  (define std/sort#vector-copy!
    (lambda (_target2451_ _src2452_ _start2453_ _end2454_)
      (subvector-move! _src2452_ _start2453_ _end2454_ _target2451_ '0)))
  (define std/sort#vector-merge-sort!
    (lambda (_v2448_ _elt<2449_)
      (std/sort#%vector-merge-sort!
       _v2448_
       _elt<2449_
       '0
       (vector-length _v2448_)
       (vector-copy _v2448_))
      _v2448_))
  (define std/sort#vector-merge-sort
    (lambda (_v2445_ _elt<2446_)
      (std/sort#vector-merge-sort! (vector-copy _v2445_) _elt<2446_)))
  (define std/sort#vector-heap-sort!
    (lambda (_v2442_ _elt<2443_)
      (std/sort#heap-sort! _v2442_ _elt<2443_)
      _v2442_))
  (define std/sort#parse-vector-start+end
    (lambda (_proc2421_ _v2422_ _args2423_)
      (let ((_vlen2425_ (vector-length _v2422_)))
        (if (pair? _args2423_)
            (let ((_start2427_ (car _args2423_)) (_args2428_ (cdr _args2423_)))
              (if (or (not (integer? _start2427_)) (< _start2427_ '0))
                  (error '"Illegal subvector START spec"
                         _proc2421_
                         _start2427_
                         _v2422_)
                  (let ((_g6303_ (if (pair? _args2428_)
                                     (let ((_end2433_ (car _args2428_))
                                           (_args2434_ (cdr _args2428_)))
                                       (if (or (not (integer? _end2433_))
                                               (< _vlen2425_ _end2433_))
                                           (error '"Illegal subvector END spec"
                                                  _proc2421_
                                                  _end2433_
                                                  _v2422_)
                                           (values _end2433_ _args2434_)))
                                     (values _vlen2425_ _args2428_))))
                    (begin
                      (let ((_g6304_ (if (##values? _g6303_)
                                         (##vector-length _g6303_)
                                         1)))
                        (if (not (##fx= _g6304_ 2))
                            (error "Context expects 2 values" _g6304_)))
                      (let ((_end2439_ (##vector-ref _g6303_ 0))
                            (_args2440_ (##vector-ref _g6303_ 1)))
                        (if (<= _start2427_ _end2439_)
                            (values _start2427_ _end2439_ _args2440_)
                            (error '"Illegal subvector START/END spec"
                                   _proc2421_
                                   _start2427_
                                   _end2439_
                                   _v2422_)))))))
            (values '0 (vector-length _v2422_) '())))))
  (define std/sort#parse-vector-final-start+end
    (lambda (_proc2413_ _v2414_ _args2415_)
      (let ((_g6305_ (std/sort#parse-vector-start+end
                      _proc2413_
                      _v2414_
                      _args2415_)))
        (begin
          (let ((_g6306_ (if (##values? _g6305_) (##vector-length _g6305_) 1)))
            (if (not (##fx= _g6306_ 3))
                (error "Context expects 3 values" _g6306_)))
          (let ((_start2417_ (##vector-ref _g6305_ 0))
                (_end2418_ (##vector-ref _g6305_ 1))
                (_rest2419_ (##vector-ref _g6305_ 2)))
            (if (pair? _rest2419_)
                (error '"Extra arguments to procedure" _proc2413_ _rest2419_)
                (values _start2417_ _end2418_)))))))
  (define std/sort#list-merge-sort
    (lambda (_lis2337_ _elt<2338_)
      (letrec ((_getrun2340_
                (lambda (_lis2403_)
                  (let _lp2405_ ((_xs2407_ (cdr _lis2403_))
                                 (_prev2408_ (car _lis2403_))
                                 (_i2409_ '1))
                    (if (pair? _xs2407_)
                        (let ((_x2411_ (car _xs2407_)))
                          (if (_elt<2338_ _x2411_ _prev2408_)
                              (values _i2409_ _xs2407_)
                              (_lp2405_
                               (cdr _xs2407_)
                               _x2411_
                               (+ _i2409_ '1))))
                        (values _i2409_ _xs2407_)))))
               (_cmerge2341_
                (lambda (_a2381_ _la2382_ _b2383_ _lb2384_)
                  (let _recur2386_ ((_x2388_ (car _a2381_))
                                    (_a2389_ _a2381_)
                                    (_la2390_ _la2382_)
                                    (_y2391_ (car _b2383_))
                                    (_b2392_ _b2383_)
                                    (_lb2393_ _lb2384_))
                    (if (_elt<2338_ _y2391_ _x2388_)
                        (cons _y2391_
                              (let ((_lb2395_ (- _lb2393_ '1)))
                                (if (= _lb2395_ '0)
                                    _a2389_
                                    (let ((_b2397_ (cdr _b2392_)))
                                      (_recur2386_
                                       _x2388_
                                       _a2389_
                                       _la2390_
                                       (car _b2397_)
                                       _b2397_
                                       _lb2395_)))))
                        (cons _x2388_
                              (let ((_la2399_ (- _la2390_ '1)))
                                (if (= _la2399_ '0)
                                    _b2392_
                                    (let ((_a2401_ (cdr _a2389_)))
                                      (_recur2386_
                                       (car _a2401_)
                                       _a2401_
                                       _la2399_
                                       _y2391_
                                       _b2392_
                                       _lb2393_)))))))))
               (_grow2342_
                (lambda (_s2357_ _ls2358_ _ls22359_ _u2360_ _lw2361_)
                  (if (or (<= _lw2361_ _ls2358_) (not (pair? _u2360_)))
                      (values _s2357_ _ls2358_ _u2360_)
                      (let* ((_ls22372_
                              (let _lp2366_ ((_ls22368_ _ls22359_))
                                (let ((_ls2*22370_ (+ _ls22368_ _ls22368_)))
                                  (if (<= _ls2*22370_ _ls2358_)
                                      (_lp2366_ _ls2*22370_)
                                      _ls22368_))))
                             (_g6307_ (_getrun2340_ _u2360_)))
                        (begin
                          (let ((_g6308_ (if (##values? _g6307_)
                                             (##vector-length _g6307_)
                                             1)))
                            (if (not (##fx= _g6308_ 2))
                                (error "Context expects 2 values" _g6308_)))
                          (let ((_lr2374_ (##vector-ref _g6307_ 0))
                                (_u22375_ (##vector-ref _g6307_ 1)))
                            (let ((_g6309_ (_grow2342_
                                            _u2360_
                                            _lr2374_
                                            '1
                                            _u22375_
                                            _ls22372_)))
                              (begin
                                (let ((_g6310_ (if (##values? _g6309_)
                                                   (##vector-length _g6309_)
                                                   1)))
                                  (if (not (##fx= _g6310_ 3))
                                      (error "Context expects 3 values"
                                             _g6310_)))
                                (let ((_t2377_ (##vector-ref _g6309_ 0))
                                      (_lt2378_ (##vector-ref _g6309_ 1))
                                      (_u32379_ (##vector-ref _g6309_ 2)))
                                  (_grow2342_
                                   (_cmerge2341_
                                    _s2357_
                                    _ls2358_
                                    _t2377_
                                    _lt2378_)
                                   (+ _ls2358_ _lt2378_)
                                   (+ _ls22372_ _ls22372_)
                                   _u32379_
                                   _lw2361_))))))))))
               (_first2343_
                (lambda (_lis2354_ _i2355_)
                  (if (= '0 _i2355_)
                      '()
                      (cons (car _lis2354_)
                            (_first2343_ (cdr _lis2354_) (- _i2355_ '1)))))))
        (if (not (pair? _lis2337_))
            '()
            (let ((_g6311_ (_getrun2340_ _lis2337_)))
              (begin
                (let ((_g6312_ (if (##values? _g6311_)
                                   (##vector-length _g6311_)
                                   1)))
                  (if (not (##fx= _g6312_ 2))
                      (error "Context expects 2 values" _g6312_)))
                (let ((_lr2345_ (##vector-ref _g6311_ 0))
                      (_tail2346_ (##vector-ref _g6311_ 1)))
                  (let* ((_infinity2348_ '16777216)
                         (_g6313_ (_grow2342_
                                   _lis2337_
                                   _lr2345_
                                   '1
                                   _tail2346_
                                   _infinity2348_)))
                    (begin
                      (let ((_g6314_ (if (##values? _g6313_)
                                         (##vector-length _g6313_)
                                         1)))
                        (if (not (##fx= _g6314_ 3))
                            (error "Context expects 3 values" _g6314_)))
                      (let ((_a2350_ (##vector-ref _g6313_ 0))
                            (_la2351_ (##vector-ref _g6313_ 1))
                            (_v2352_ (##vector-ref _g6313_ 2)))
                        (_first2343_ _a2350_ _la2351_)))))))))))
  (define std/sort#list-merge-sort!
    (lambda (_lis2242_ _elt<2243_)
      (letrec ((_getrun2245_
                (lambda (_lis2326_)
                  (let _lp2328_ ((_lis2330_ _lis2326_)
                                 (_x2331_ (car _lis2326_))
                                 (_i2332_ '1)
                                 (_next2333_ (cdr _lis2326_)))
                    (if (pair? _next2333_)
                        (let ((_y2335_ (car _next2333_)))
                          (if (_elt<2243_ _y2335_ _x2331_)
                              (values _i2332_ _lis2330_ _next2333_)
                              (_lp2328_
                               _next2333_
                               _y2335_
                               (+ _i2332_ '1)
                               (cdr _next2333_))))
                        (values _i2332_ _lis2330_ _next2333_)))))
               (_merge!2246_
                (lambda (_a2287_ _enda2288_ _b2289_ _endb2290_)
                  (letrec ((_scan-a2292_
                            (lambda (_prev2296_
                                     _x2297_
                                     _a2298_
                                     _y2299_
                                     _b2300_)
                              (if (_elt<2243_ _y2299_ _x2297_)
                                  (begin
                                    (set-cdr! _prev2296_ _b2300_)
                                    (let ((_next-b2302_ (cdr _b2300_)))
                                      (if (eq? _b2300_ _endb2290_)
                                          (begin
                                            (set-cdr! _b2300_ _a2298_)
                                            _enda2288_)
                                          (_scan-b2293_
                                           _b2300_
                                           _x2297_
                                           _a2298_
                                           (car _next-b2302_)
                                           _next-b2302_))))
                                  (if (eq? _a2298_ _enda2288_)
                                      (begin
                                        (_maybe-set-cdr!2294_ _a2298_ _b2300_)
                                        _endb2290_)
                                      (let ((_next-a2304_ (cdr _a2298_)))
                                        (_scan-a2292_
                                         _a2298_
                                         (car _next-a2304_)
                                         _next-a2304_
                                         _y2299_
                                         _b2300_))))))
                           (_scan-b2293_
                            (lambda (_prev2306_
                                     _x2307_
                                     _a2308_
                                     _y2309_
                                     _b2310_)
                              (if (_elt<2243_ _y2309_ _x2307_)
                                  (if (eq? _b2310_ _endb2290_)
                                      (begin
                                        (set-cdr! _b2310_ _a2308_)
                                        _enda2288_)
                                      (let ((_next-b2312_ (cdr _b2310_)))
                                        (_scan-b2293_
                                         _b2310_
                                         _x2307_
                                         _a2308_
                                         (car _next-b2312_)
                                         _next-b2312_)))
                                  (begin
                                    (set-cdr! _prev2306_ _a2308_)
                                    (if (eq? _a2308_ _enda2288_)
                                        (begin
                                          (_maybe-set-cdr!2294_
                                           _a2308_
                                           _b2310_)
                                          _endb2290_)
                                        (let ((_next-a2314_ (cdr _a2308_)))
                                          (_scan-a2292_
                                           _a2308_
                                           (car _next-a2314_)
                                           _next-a2314_
                                           _y2309_
                                           _b2310_)))))))
                           (_maybe-set-cdr!2294_
                            (lambda (_pair2316_ _val2317_)
                              (if (not (eq? (cdr _pair2316_) _val2317_))
                                  (set-cdr! _pair2316_ _val2317_)
                                  '#!void))))
                    (let ((_x2319_ (car _a2287_)) (_y2320_ (car _b2289_)))
                      (if (_elt<2243_ _y2320_ _x2319_)
                          (values _b2289_
                                  (if (eq? _b2289_ _endb2290_)
                                      (begin
                                        (set-cdr! _b2289_ _a2287_)
                                        _enda2288_)
                                      (let ((_next-b2322_ (cdr _b2289_)))
                                        (_scan-b2293_
                                         _b2289_
                                         _x2319_
                                         _a2287_
                                         (car _next-b2322_)
                                         _next-b2322_))))
                          (values _a2287_
                                  (if (eq? _a2287_ _enda2288_)
                                      (begin
                                        (_maybe-set-cdr!2294_ _a2287_ _b2289_)
                                        _endb2290_)
                                      (let ((_next-a2324_ (cdr _a2287_)))
                                        (_scan-a2292_
                                         _a2287_
                                         (car _next-a2324_)
                                         _next-a2324_
                                         _y2320_
                                         _b2289_)))))))))
               (_grow2247_
                (lambda (_s2260_
                         _ends2261_
                         _ls2262_
                         _ls22263_
                         _u2264_
                         _lw2265_)
                  (if (and (pair? _u2264_) (< _ls2262_ _lw2265_))
                      (let* ((_ls22273_
                              (let _lp2267_ ((_ls22269_ _ls22263_))
                                (let ((_ls2*22271_ (+ _ls22269_ _ls22269_)))
                                  (if (<= _ls2*22271_ _ls2262_)
                                      (_lp2267_ _ls2*22271_)
                                      _ls22269_))))
                             (_g6315_ (_getrun2245_ _u2264_)))
                        (begin
                          (let ((_g6316_ (if (##values? _g6315_)
                                             (##vector-length _g6315_)
                                             1)))
                            (if (not (##fx= _g6316_ 3))
                                (error "Context expects 3 values" _g6316_)))
                          (let ((_lr2275_ (##vector-ref _g6315_ 0))
                                (_endr2276_ (##vector-ref _g6315_ 1))
                                (_u22277_ (##vector-ref _g6315_ 2)))
                            (let ((_g6317_ (_grow2247_
                                            _u2264_
                                            _endr2276_
                                            _lr2275_
                                            '1
                                            _u22277_
                                            _ls22273_)))
                              (begin
                                (let ((_g6318_ (if (##values? _g6317_)
                                                   (##vector-length _g6317_)
                                                   1)))
                                  (if (not (##fx= _g6318_ 4))
                                      (error "Context expects 4 values"
                                             _g6318_)))
                                (let ((_t2279_ (##vector-ref _g6317_ 0))
                                      (_endt2280_ (##vector-ref _g6317_ 1))
                                      (_lt2281_ (##vector-ref _g6317_ 2))
                                      (_u32282_ (##vector-ref _g6317_ 3)))
                                  (let ((_g6319_ (_merge!2246_
                                                  _s2260_
                                                  _ends2261_
                                                  _t2279_
                                                  _endt2280_)))
                                    (begin
                                      (let ((_g6320_ (if (##values? _g6319_)
                                                         (##vector-length
                                                          _g6319_)
                                                         1)))
                                        (if (not (##fx= _g6320_ 2))
                                            (error "Context expects 2 values"
                                                   _g6320_)))
                                      (let ((_st2284_ (##vector-ref _g6319_ 0))
                                            (_end-st2285_
                                             (##vector-ref _g6319_ 1)))
                                        (_grow2247_
                                         _st2284_
                                         _end-st2285_
                                         (+ _ls2262_ _lt2281_)
                                         (+ _ls22273_ _ls22273_)
                                         _u32282_
                                         _lw2265_))))))))))
                      (values _s2260_ _ends2261_ _ls2262_ _u2264_)))))
        (if (pair? _lis2242_)
            (let ((_g6321_ (_getrun2245_ _lis2242_)))
              (begin
                (let ((_g6322_ (if (##values? _g6321_)
                                   (##vector-length _g6321_)
                                   1)))
                  (if (not (##fx= _g6322_ 3))
                      (error "Context expects 3 values" _g6322_)))
                (let ((_lr2249_ (##vector-ref _g6321_ 0))
                      (_endr2250_ (##vector-ref _g6321_ 1))
                      (_rest2251_ (##vector-ref _g6321_ 2)))
                  (let* ((_infinity2253_ '16777216)
                         (_g6323_ (_grow2247_
                                   _lis2242_
                                   _endr2250_
                                   _lr2249_
                                   '1
                                   _rest2251_
                                   _infinity2253_)))
                    (begin
                      (let ((_g6324_ (if (##values? _g6323_)
                                         (##vector-length _g6323_)
                                         1)))
                        (if (not (##fx= _g6324_ 4))
                            (error "Context expects 4 values" _g6324_)))
                      (let ((_a2255_ (##vector-ref _g6323_ 0))
                            (_enda2256_ (##vector-ref _g6323_ 1))
                            (_la2257_ (##vector-ref _g6323_ 2))
                            (_v2258_ (##vector-ref _g6323_ 3)))
                        (begin (set-cdr! _enda2256_ '()) _a2255_)))))))
            '()))))
  (define std/sort#really-heap-sort!
    (lambda (_v2193_ _elt<2194_ _start2195_ _end2196_)
      (letrec ((_restore-heap!2198_
                (lambda (_end2214_ _i2215_)
                  (let* ((_vi2217_ (vector-ref _v2193_ _i2215_))
                         (_first-leaf2219_
                          (quotient (+ _start2195_ _end2214_) '2))
                         (_final-k2239_
                          (let _lp2221_ ((_k2223_ _i2215_))
                            (if (>= _k2223_ _first-leaf2219_)
                                _k2223_
                                (let* ((_k*2-start2225_
                                        (+ _k2223_ (- _k2223_ _start2195_)))
                                       (_child12227_ (+ '1 _k*2-start2225_))
                                       (_child22229_ (+ '2 _k*2-start2225_))
                                       (_child1-val2231_
                                        (vector-ref _v2193_ _child12227_)))
                                  (let ((_g6325_ (if (< _child22229_ _end2214_)
                                                     (let ((_child2-val2234_
                                                            (vector-ref
                                                             _v2193_
                                                             _child22229_)))
                                                       (if (_elt<2194_
                                                            _child2-val2234_
                                                            _child1-val2231_)
                                                           (values _child12227_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _child1-val2231_)
                   (values _child22229_ _child2-val2234_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (values _child12227_
                                                             _child1-val2231_))))
                                    (begin
                                      #!void
                                      (let ((_max-child2236_
                                             (##vector-ref _g6325_ 0))
                                            (_max-child-val2237_
                                             (##vector-ref _g6325_ 1)))
                                        (if (_elt<2194_
                                             _vi2217_
                                             _max-child-val2237_)
                                            (begin
                                              (vector-set!
                                               _v2193_
                                               _k2223_
                                               _max-child-val2237_)
                                              (_lp2221_ _max-child2236_))
                                            _k2223_)))))))))
                    (vector-set! _v2193_ _final-k2239_ _vi2217_)))))
        (let ((_first-leaf2200_ (quotient (+ _start2195_ _end2196_) '2)))
          (let _$loop2202_ ((_i2205_ (- _first-leaf2200_ '1)))
            (if (< _i2205_ '0)
                '#!void
                (begin
                  (_restore-heap!2198_ _end2196_ _i2205_)
                  (_$loop2202_ (- _i2205_ '1))))))
        (let _$loop2207_ ((_i2210_ (- _end2196_ '1)))
          (if (<= _i2210_ '0)
              '#!void
              (begin
                (let ((_top2212_ (vector-ref _v2193_ _start2195_)))
                  (vector-set!
                   _v2193_
                   _start2195_
                   (vector-ref _v2193_ _i2210_))
                  (vector-set! _v2193_ _i2210_ _top2212_)
                  (_restore-heap!2198_ _i2210_ _start2195_))
                (_$loop2207_ (- _i2210_ '1))))))))
  (define std/sort#heap-sort!
    (lambda (_v2186_ _elt<2187_ . _maybe-start+end2188_)
      (let ((_g6326_ (std/sort#parse-vector-final-start+end
                      std/sort#heap-sort!
                      _v2186_
                      _maybe-start+end2188_)))
        (begin
          (let ((_g6327_ (if (##values? _g6326_) (##vector-length _g6326_) 1)))
            (if (not (##fx= _g6327_ 2))
                (error "Context expects 2 values" _g6327_)))
          (let ((_start2190_ (##vector-ref _g6326_ 0))
                (_end2191_ (##vector-ref _g6326_ 1)))
            (std/sort#really-heap-sort!
             _v2186_
             _elt<2187_
             _start2190_
             _end2191_))))))
  (define std/sort#heap-sort
    (lambda (_v2177_ _elt<2178_ . _maybe-start+end2179_)
      (let ((_g6328_ (std/sort#parse-vector-final-start+end
                      std/sort#heap-sort
                      _v2177_
                      _maybe-start+end2179_)))
        (begin
          (let ((_g6329_ (if (##values? _g6328_) (##vector-length _g6328_) 1)))
            (if (not (##fx= _g6329_ 2))
                (error "Context expects 2 values" _g6329_)))
          (let ((_start2181_ (##vector-ref _g6328_ 0))
                (_end2182_ (##vector-ref _g6328_ 1)))
            (let ((_ans2184_ (subvector _v2177_ _start2181_ _end2182_)))
              (std/sort#really-heap-sort!
               _ans2184_
               _elt<2178_
               '0
               (- _end2182_ _start2181_))
              _ans2184_))))))
  (define std/sort#%vector-merge!
    (lambda (_v2139_
             _v12140_
             _v22141_
             _elt<2142_
             _start02143_
             _start12144_
             _end12145_
             _start22146_
             _end22147_)
      (letrec ((_vblit2149_
                (lambda (_fromv2151_ _j2152_ _i2153_ _end2154_)
                  (let _lp2156_ ((_j2158_ _j2152_) (_i2159_ _i2153_))
                    (vector-set!
                     _v2139_
                     _i2159_
                     (vector-ref _fromv2151_ _j2158_))
                    (let ((_j2161_ (+ _j2158_ '1)))
                      (if (< _j2161_ _end2154_)
                          (_lp2156_ _j2161_ (+ _i2159_ '1))
                          '#!void))))))
        (if (<= _end12145_ _start12144_)
            (if (< _start22146_ _end22147_)
                (_vblit2149_ _v22141_ _start22146_ _start02143_ _end22147_)
                '#!void)
            (if (<= _end22147_ _start22146_)
                (_vblit2149_ _v12140_ _start12144_ _start02143_ _end12145_)
                (let _lp2163_ ((_i2165_ _start02143_)
                               (_j2166_ _start12144_)
                               (_x2167_ (vector-ref _v12140_ _start12144_))
                               (_k2168_ _start22146_)
                               (_y2169_ (vector-ref _v22141_ _start22146_)))
                  (let ((_i12171_ (+ _i2165_ '1)))
                    (if (_elt<2142_ _y2169_ _x2167_)
                        (let ((_k2173_ (+ _k2168_ '1)))
                          (vector-set! _v2139_ _i2165_ _y2169_)
                          (if (< _k2173_ _end22147_)
                              (_lp2163_
                               _i12171_
                               _j2166_
                               _x2167_
                               _k2173_
                               (vector-ref _v22141_ _k2173_))
                              (_vblit2149_
                               _v12140_
                               _j2166_
                               _i12171_
                               _end12145_)))
                        (let ((_j2175_ (+ _j2166_ '1)))
                          (vector-set! _v2139_ _i2165_ _x2167_)
                          (if (< _j2175_ _end12145_)
                              (_vblit2149_
                               _v22141_
                               _k2168_
                               _i12171_
                               _end22147_)
                              (_lp2163_
                               _i12171_
                               _j2175_
                               (vector-ref _v12140_ _j2175_)
                               _k2168_
                               _y2169_)))))))))))
  (define std/sort#%vector-merge-sort!
    (lambda (_v02093_ _elt<2094_ _l2095_ _r2096_ _temp02097_)
      (letrec ((_xor2099_
                (lambda (_a2136_ _b2137_) (not (eq? _a2136_ _b2137_)))))
        (if (< _l2095_ _r2096_)
            (let ((_g6330_ (let _recur2101_ ((_l2103_ _l2095_)
                                             (_want2104_ (- _r2096_ _l2095_)))
                             (let ((_len2106_ (- _r2096_ _l2103_)))
                               (let _lp2108_ ((_pfxlen2110_
                                               (std/sort#getrun
                                                _v02093_
                                                _l2103_
                                                _r2096_
                                                _elt<2094_))
                                              (_pfxlen22111_ '1)
                                              (_v2112_ _v02093_)
                                              (_temp2113_ _temp02097_)
                                              (_v=v0?2114_ '#t))
                                 (if (or (>= _pfxlen2110_ _want2104_)
                                         (= _pfxlen2110_ _len2106_))
                                     (values _pfxlen2110_ _v2112_ _v=v0?2114_)
                                     (let ((_pfxlen22125_
                                            (let _lp2119_ ((_j2121_ _pfxlen22111_))
                                              (let ((_j*22123_
                                                     (+ _j2121_ _j2121_)))
                                                (if (<= _j2121_ _pfxlen2110_)
                                                    (_lp2119_ _j*22123_)
                                                    _j2121_))))
                                           (_tail-len2126_
                                            (- _len2106_ _pfxlen2110_)))
                                       (let ((_g6332_ (_recur2101_
                                                       (+ _pfxlen2110_ _l2103_)
                                                       _pfxlen22125_)))
                                         (begin
                                           (let ((_g6333_ (if (##values?
                                                               _g6332_)
                                                              (##vector-length
                                                               _g6332_)
                                                              1)))
                                             (if (not (##fx= _g6333_ 3))
                                                 (error "Context expects 3 values"
                                                        _g6333_)))
                                           (let ((_nr-len2128_
                                                  (##vector-ref _g6332_ 0))
                                                 (_nr-vec2129_
                                                  (##vector-ref _g6332_ 1))
                                                 (_nrvec=v0?2130_
                                                  (##vector-ref _g6332_ 2)))
                                             (begin
                                               (std/sort#%vmerge
                                                _temp2113_
                                                _v2112_
                                                _nr-vec2129_
                                                _l2103_
                                                _pfxlen2110_
                                                _nr-len2128_
                                                (_xor2099_
                                                 _nrvec=v0?2130_
                                                 _v=v0?2114_)
                                                _elt<2094_)
                                               (_lp2108_
                                                (+ _pfxlen2110_ _nr-len2128_)
                                                (+ _pfxlen22125_ _pfxlen22125_)
                                                _temp2113_
                                                _v2112_
                                                (not _v=v0?2114_)))))))))))))
              (begin
                (let ((_g6331_ (if (##values? _g6330_)
                                   (##vector-length _g6330_)
                                   1)))
                  (if (not (##fx= _g6331_ 3))
                      (error "Context expects 3 values" _g6331_)))
                (let ((_ignored-len2132_ (##vector-ref _g6330_ 0))
                      (_ignored-ansvec2133_ (##vector-ref _g6330_ 1))
                      (_ansvec=v0?2134_ (##vector-ref _g6330_ 2)))
                  (if (not _ansvec=v0?2134_)
                      (std/sort#vector-copy!
                       _v02093_
                       _temp02097_
                       _l2095_
                       _r2096_)
                      '#!void))))
            '#!void))))
  (define std/sort#%vmerge
    (lambda (_target2051_
             _v12052_
             _v22053_
             _l2054_
             _len12055_
             _len22056_
             _v2=target?2057_
             _elt<2058_)
      (letrec ((_vblit2060_
                (lambda (_fromv2062_ _j2063_ _i2064_ _end2065_)
                  (let _lp2067_ ((_j2069_ _j2063_) (_i2070_ _i2064_))
                    (vector-set!
                     _target2051_
                     _i2070_
                     (vector-ref _fromv2062_ _j2069_))
                    (let ((_j2072_ (+ _j2069_ '1)))
                      (if (< _j2072_ _end2065_)
                          (_lp2067_ _j2072_ (+ _i2070_ '1))
                          '#!void))))))
        (let* ((_r12074_ (+ _l2054_ _len12055_))
               (_r22076_ (+ _r12074_ _len22056_)))
          (let _lp2079_ ((_i2081_ _l2054_)
                         (_j2082_ _l2054_)
                         (_x2083_ (vector-ref _v12052_ _l2054_))
                         (_k2084_ _r12074_)
                         (_y2085_ (vector-ref _v22053_ _r12074_)))
            (let ((_i12087_ (+ _i2081_ '1)))
              (if (_elt<2058_ _y2085_ _x2083_)
                  (let ((_k2089_ (+ _k2084_ '1)))
                    (vector-set! _target2051_ _i2081_ _y2085_)
                    (if (< _k2089_ _r22076_)
                        (_lp2079_
                         _i12087_
                         _j2082_
                         _x2083_
                         _k2089_
                         (vector-ref _v22053_ _k2089_))
                        (_vblit2060_ _v12052_ _j2082_ _i12087_ _r12074_)))
                  (let ((_j2091_ (+ _j2082_ '1)))
                    (vector-set! _target2051_ _i2081_ _x2083_)
                    (if (< _j2091_ _r12074_)
                        (_lp2079_
                         _i12087_
                         _j2091_
                         (vector-ref _v12052_ _j2091_)
                         _k2084_
                         _y2085_)
                        (if (not _v2=target?2057_)
                            (_vblit2060_ _v22053_ _k2084_ _i12087_ _r22076_)
                            '#!void))))))))))
  (define std/sort#getrun
    (lambda (_v2039_ _l2040_ _r2041_ _elt<2042_)
      (let _lp2044_ ((_i2046_ (+ _l2040_ '1))
                     (_x2047_ (vector-ref _v2039_ _l2040_)))
        (if (>= _i2046_ _r2041_)
            (- _i2046_ _l2040_)
            (let ((_y2049_ (vector-ref _v2039_ _i2046_)))
              (if (_elt<2042_ _y2049_ _x2047_)
                  (- _i2046_ _l2040_)
                  (_lp2044_ (+ _i2046_ '1) _y2049_)))))))
  (define std/sort#list-sorted?
    (lambda (_list2023_ _<2024_)
      (let ((_$e2026_ (not (pair? _list2023_))))
        (if _$e2026_
            _$e2026_
            (let _lp2029_ ((_prev2031_ (car _list2023_))
                           (_tail2032_ (cdr _list2023_)))
              (let ((_$e2034_ (not (pair? _tail2032_))))
                (if _$e2034_
                    _$e2034_
                    (let ((_next2037_ (car _tail2032_)))
                      (if (not (_<2024_ _next2037_ _prev2031_))
                          (_lp2029_ _next2037_ (cdr _tail2032_))
                          '#f)))))))))
  (define std/sort#vector-sorted?
    (lambda (_v2003_ _elt<2004_ . _maybe-start+end2005_)
      (if (vector? _v2003_) '#!void (error '"Expected vector" _v2003_))
      (let ((_g6334_ (std/sort#parse-vector-final-start+end
                      std/sort#vector-sorted?
                      _v2003_
                      _maybe-start+end2005_)))
        (begin
          (let ((_g6335_ (if (##values? _g6334_) (##vector-length _g6334_) 1)))
            (if (not (##fx= _g6335_ 2))
                (error "Context expects 2 values" _g6335_)))
          (let ((_start2007_ (##vector-ref _g6334_ 0))
                (_end2008_ (##vector-ref _g6334_ 1)))
            (let ((_$e2010_ (>= _start2007_ _end2008_)))
              (if _$e2010_
                  _$e2010_
                  (let _lp2013_ ((_i2015_ (+ _start2007_ '1))
                                 (_vi-12016_ (vector-ref _v2003_ _start2007_)))
                    (let ((_$e2018_ (>= _i2015_ _end2008_)))
                      (if _$e2018_
                          _$e2018_
                          (let ((_vi2021_ (vector-ref _v2003_ _i2015_)))
                            (if (not (_elt<2004_ _vi2021_ _vi-12016_))
                                (_lp2013_ (+ _i2015_ '1) _vi2021_)
                                '#f)))))))))))))
